program uliz;
uses moja;

const MENO_SUBORU = 'slova.txt';

type smernik = ^struct;
     struct  =  record
                  slovo : string;
                  sused : smernik;
                end;

var zaciatok : smernik;
    subor    : text;
    slovo    : string;

procedure zaradslovo(slovo : string);
var novy, clen, posledny : smernik;
begin

  (* na zaciatok *)
  if (zaciatok=nil) or (slovo<zaciatok^.slovo) then begin
    new(novy);
    novy^.slovo:=slovo;
    novy^.sused:=zaciatok;
    zaciatok:=novy;
    slovo:='';
  end

  (* niekde uprostred *)
  else begin
    clen:=zaciatok^.sused;
    while (clen<>nil) and (slovo<>'') do begin
      if slovo<clen^.slovo then begin
        new(novy);
        novy^.slovo:=clen^.slovo;
        novy^.sused:=clen^.sused;
        clen^.slovo:=slovo;
        clen^.sused:=novy;
        slovo:='';
      end;
      clen:=clen^.sused;
      if (clen^.sused)^.sused=nil then posledny:=clen^.sused;
    end;
  end;

  (* na koniec *)
  if slovo<>'' then begin
    new(novy);
    novy^.sused:=nil;
    novy^.slovo:=slovo;
    posledny^.sused:=novy;
  end;                            

end;

procedure vypis;
var clen : smernik;
begin
  clen:=zaciatok; assign(subor, ''); rewrite(subor);
  while clen<>nil do begin
    writeln(subor, clen^.slovo);
    clen:=clen^.sused;
  end;
end;

begin
  zaciatok:=nil;
  {$I-}
    assign(subor, MENO_SUBORU);
    reset(subor);
  {$I+}
  if ioresult<>0 then begin
    writeln('subor ', MENO_SUBORU, ' neexistuje');
    halt(1);
  end;

  while not eof(subor) do begin
    slovo:=dajslovo(subor);
    if slovo<>'' then zaradslovo(slovo);
  end;
  close(subor);

  vypis; readln;
end.